/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// ExportStatus the model 'ExportStatus'
type ExportStatus string

// List of ExportStatus
const (
	EXPORT_STATUS_PENDING ExportStatus = "pending"
	EXPORT_STATUS_READY ExportStatus = "ready"
	EXPORT_STATUS_FAILED ExportStatus = "failed"
)

// All allowed values of ExportStatus enum
var AllowedExportStatusEnumValues = []ExportStatus{
	"pending",
	"ready",
	"failed",
}

func (v *ExportStatus) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ExportStatus(value)
	for _, existing := range AllowedExportStatusEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ExportStatus", value)
}

// NewExportStatusFromValue returns a pointer to a valid ExportStatus
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewExportStatusFromValue(v string) (*ExportStatus, error) {
	ev := ExportStatus(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ExportStatus: valid values are %v", v, AllowedExportStatusEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ExportStatus) IsValid() bool {
	for _, existing := range AllowedExportStatusEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ExportStatus value
func (v ExportStatus) Ptr() *ExportStatus {
	return &v
}

type NullableExportStatus struct {
	value *ExportStatus
	isSet bool
}

func (v NullableExportStatus) Get() *ExportStatus {
	return v.value
}

func (v *NullableExportStatus) Set(val *ExportStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableExportStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableExportStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExportStatus(val *ExportStatus) *NullableExportStatus {
	return &NullableExportStatus{value: val, isSet: true}
}

func (v NullableExportStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExportStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

